﻿using AspNetCoreSsrTemplateEngine.Template;

namespace AspNetCoreSsrTemplateEngine.DataBoundContext
{
    internal class CascadeDataBindContext : SimpleDataBindContext
    {
        private readonly IReadonlyDataBindContext _underlying;

        public CascadeDataBindContext(IReadonlyDataBindContext underlying)
        {
            _underlying = underlying;
        }

        public override bool TryGetValue(string key, out object value)
        {
            return base.TryGetValue(key, out value) || _underlying.TryGetValue(key, out value);
        }

        public override bool TryGetTemplate(string key, out ITemplate slot)
        {
            return base.TryGetTemplate(key, out slot) || _underlying.TryGetTemplate(key, out slot);
        }
    }
}
