﻿using System.Diagnostics;
using System.IO;
using System.Threading.Tasks;
using AspNetCoreSsrTemplateEngine.DataBoundContext;
using AspNetCoreSsrTemplateEngine.Utils;

namespace AspNetCoreSsrTemplateEngine.Renders
{
    [DebuggerDisplay("Output: {" + nameof(Key) + ",nq}")]
    internal class OutputRender : IRender
    {
        public string Key { get; }

        public OutputRender(string key)
        {
            Key = key;
        }

        public async Task RenderAsync(IReadonlyDataBindContext dataBindContext, Stream stream)
        {
            var content = dataBindContext.GetValue(Key);
            if (null == content) return;
            await stream.WriteUtf8Async(content.ToString());
        }
    }
}
