﻿using System.Collections.Generic;
using System.IO;
using System.Threading.Tasks;
using AspNetCoreSsrTemplateEngine.DataBoundContext;
using AspNetCoreSsrTemplateEngine.Renders;

namespace AspNetCoreSsrTemplateEngine.Template
{
    internal class SimpleTemplate : ITemplate
    {
        private readonly IReadOnlyList<IRender> _renderSequence;

        public SimpleTemplate(IReadOnlyList<IRender> renderSequence)
        {
            _renderSequence = renderSequence;
        }

        public async Task RenderAsync(IReadonlyDataBindContext dataBindContext, Stream stream)
        {
            foreach (var render in _renderSequence)
            {
                await render.RenderAsync(dataBindContext, stream);
            }
        }
    }
}
