﻿using System.IO;
using System.Text;
using System.Threading.Tasks;

namespace AspNetCoreSsrTemplateEngine.Utils
{
    internal static class StreamExtensionMethod
    {


        public static string ReadUtf8(this Stream stream)
        {
            using (var ms = new MemoryStream())
            {
                stream.CopyTo(ms);
                return Encoding.UTF8.GetString(ms.ToArray());
            }
        }

        public static async Task WriteUtf8Async(this Stream stream, string s)
        {
            var bytes = Encoding.UTF8.GetBytes(s);
            await stream.WriteAsync(bytes, 0, bytes.Length);

        }
    }
}
